	cpu	6800
	relaxed on
	
SOURCE	EQU	$4000
END		EQU	$7fff
DESTINATION	EQU	$8000

KNOCK	MACRO	PAGE, LOC, DATA
	LDA	A, #PAGE
	STA	A, $C0FF
	LDA	A, #DATA
	STA	A, LOC
	ENDM

FCMD	MACRO	COMMAND
	KNOCK	$01, $9555, $AA     ;Write 0xAA to 0x8000 + 0x1555 = 0x9555, page 0x01
	KNOCK $00, $AAAA, $55     ;Write 0x55 to 0x8000 + 0x2AAA = 0xAAAA, page 0x00
	KNOCK $01, $9555, COMMAND ;Write Command to 0x8000 + 0x1555 = 0x9555, page 0x01
	ENDM

	ORG	$200
PGREG	RMB	1	;PAGE
READ	RMB	2	;Counter for SOURCE location
WRITE	RMB	2	;Counter for DESTINATION location
BYTE	RMB	1	;Counter for current block
TEMP	RMB	1	;For pause routine

	ORG	$1000
	LDX	#SOURCE		;Source Location
	STX	READ			;Counter
	LDX	#DESTINATION	;Destination Location
	STX	WRITE			;Counter
	LDA	A, #0
	STA	A, BYTE		;block counter
LOOPS	CLRB
	CLR	$3507

	FCMD	$A0		;Unprotect flash
	LDA	A, PGREG
	STA	A, $C0FF

LOOP:	LDX	READ		;Read a byte from source
	LDA	B, 0, X
	INX
	STX	READ
	
	LDX	WRITE		;Write it to destination
	STA	B, 0, X
	INX
	STX	WRITE
	LDA	A, BYTE	;Have we done 256 bytes?
	CMP	A, #$FF
	BEQ	WAIT
	INC	BYTE
	JMP	LOOP

WAIT:	JSR	PAUSE		;Pause for a little bit
	CLR	BYTE		;Clear block counter
	LDX	READ
	CPX	#$8000
	BEQ	EXIT
	LDA	A, DESTINATION
	NOP
	LDA	B, DESTINATION
	CBA
	BEQ	LOOPS
	INC	$3507
	JMP	WAIT

EXIT:	JMP	$FFAB

;***** Pause to let programming start
PAUSE	LDA	A, #0		;Starting
	STA	A, TEMP
	LDA	A, #50	;Ending
PLOOP	CMP	A, TEMP
	BEQ	PEND
	INC	TEMP
	JMP	PLOOP
PEND	RTS
